#include "csurf.h"

fmpz tmp[TMPS_NUM];

int main() {
  init_tmps();
  
  flint_rand_t rng;
  flint_randinit(rng);
  
  short a[CSIDH_LEN], b[CSIDH_LEN];

  fmpz_mod_ctx_t p; curve E, E1;

  CSIDH_ctx(p);
  curve_init(E);
  curve_init(E1);
  CSIDH_start(E, p);

  for (int i = 0; i < 20; i++) {
    CSIDH_random_sk(a, rng);
    CSIDH_random_sk(b, rng);
    CSIDH_action(E1, E, a, p, rng, 40*(i+1));
    CSIDH_action(E1, E1, b, p, rng, 40*(i+1));
    CSIDH_action(E, E, b, p, rng, 40*(i+1));
    CSIDH_action(E, E, a, p, rng, 40*(i+1));

    assert(curve_equal(E, E1, p));
  }

  fmpz_mod_ctx_clear(p);
  CSURF_ctx(p);
  CSURF_start(E, p);

  for (int i = 0; i < 20; i++) {
    CSURF_random_sk(a, rng);
    CSURF_random_sk(b, rng);
    CSURF_action(E1, E, a, p, rng, 40*(i+1));
    CSURF_action(E1, E1, b, p, rng, 40*(i+1));
    CSURF_action(E, E, b, p, rng, 40*(i+1));
    CSURF_action(E, E, a, p, rng, 40*(i+1));

    assert(curve_equal(E, E1, p));
  }

  printf("    \033[1;32mAll tests passed\033[0m\n");
  exit(0);
}
